module wei_wavespace_type_mod
  use sep3d_struct_mod
  use wei_slow_type_mod

  type component
    type(wslow),pointer         :: slow
    integer,pointer        :: x(:,:),y(:,:)
  end type

  type wspace
    real,    dimension(:),         pointer :: kmx,kmy,khx,khy
    real,    dimension(:,:),       pointer :: ksx,ksy,krx,kry ! f(m,h)

    integer                                :: n(4)            ! Axis sizes
    integer                                :: npad(4)         !Padded axes sizes
    real                                   :: o(4),d(4)       ! Origin and sampling of axes
    real                                   :: opad(4),dpad(4) ! Origin and sampling of axes padded

    real                 :: z0                     !initial depth
    real,pointer         :: ws(:),dz(:)            !omegas and dz

    integer              :: istruct                !instance of this data
    integer              :: nth                    !number of threads
    logical              :: adj                    !forward or adjoint
    real                 :: opsign                 !operation sign

    integer              :: nzb                   !depth block

!    integer              :: npadx,npady            !padding for wavefield
    real,    pointer :: scale_x(:),scale_y(:)  !amplitude for padding

    type(wslow),pointer          :: slow1,slow2
    type(component)      :: src,rec

    integer              :: finished               !amount of work finished
    integer              ::  mem_save

  end  type 
end module
